'From Squeak 2.1 of June 30, 1998 on 20 September 1998 at 9:15:41 pm'!
Object subclass: #Permutation
	instanceVariableNames: 'contents '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Examples'!
Permutation subclass: #CyclicPermutation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Examples'!
SimpleMorphicWrapper subclass: #PermutationWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Examples'!

!Permutation methodsFor: 'mathematics' stamp: 'LC 8/19/1998 03:11'!
@ aPermutation
	"Composition"
	| answer |
	answer _ self class new: self n.
	1 to: self n do: [:k | answer at: k put: (self at: (aPermutation at: k))].
	^ answer! !

!Permutation methodsFor: 'mathematics' stamp: 'LC 8/18/1998 23:28'!
at: i
	^ contents at: i! !

!Permutation methodsFor: 'mathematics' stamp: 'LC 8/19/1998 00:28'!
index
	| answer |
	answer _ 0.
	1 to: self n - 1 do: [:k | (self at: k) > (self at: k + 1) ifTrue: [answer _ answer + k]].
	^ answer! !

!Permutation methodsFor: 'mathematics' stamp: 'LC 8/18/1998 22:30'!
indexOf: j
	1 to: self n do: [:k | (self at: k) = j ifTrue: [^ k]].
	^ j
! !

!Permutation methodsFor: 'mathematics' stamp: 'LC 8/31/1998 08:48'!
inverse
	| answer |
	answer _ self class new: self n.
	1 to: self n do: [:i | answer at: (self at: i) put: i].
	^ answer! !

!Permutation methodsFor: 'mathematics' stamp: 'LC 8/31/1998 09:26'!
inverseAt: j
	^ self indexOf: j! !

!Permutation methodsFor: 'mathematics' stamp: 'LC 8/18/1998 22:33'!
inversion
	| answer |
	answer _ Array new: self n.
	1 to: self n do: [:k | answer at: k put: (self inversionAt: k)].
	^ answer! !

!Permutation methodsFor: 'mathematics' stamp: 'LC 8/18/1998 23:44'!
inversionAt: j
	| answer |
	answer _ 0.
	self do:
		[:a |
		a = j
			ifTrue: [^ answer]
			ifFalse:
				[a > j ifTrue: [answer _ answer + 1]]]
		! !

!Permutation methodsFor: 'mathematics' stamp: 'LC 8/18/1998 23:59'!
inversionSet
	| answer |
	answer _ Set new.
	1 to: self n - 1 do:
		[:i |
		i + 1 to: self n do:
			[:j |
			(self at: i) > (self at: j)
				ifTrue:
					[answer add: (Array with: (self at: i) with: (self at: j))]]].
	^ answer! !

!Permutation methodsFor: 'mathematics' stamp: 'LC 8/18/1998 23:52'!
inversions
	^ self inversion inject: 0 into: [:result :b | result + b]! !

!Permutation methodsFor: 'mathematics' stamp: 'LC 8/18/1998 23:28'!
n
	^ contents size! !

!Permutation methodsFor: 'mathematics' stamp: 'LC 8/19/1998 03:03'!
next
	"Change the receiver to the next permutation of its elements.
	Answer the receiver.
	#(4 3 2 6 5 1) next 
	"
	| k i j pivot |
"Step 1. Compute the 'last increasing pair'"
	k _ self n - 1.
	[(self at: k) < (self at: k + 1)] whileFalse: 
		[(k _ k - 1) = 0 ifTrue: [^ contents _ (1 to: self n) asArray]].
"Step 2. 'Reverse the tail'"
	i _ k + 1.
	j _ self n.
	[i < j] whileTrue: [self swap: i with: j. i _ i + 1. j _ j - 1].
"
Step 3. Find the first element greater than (self at: k) in the tail"
	pivot _ self at: k.
	i _ k + 1.
	[pivot < (self at: i)] whileFalse: [i _ i + 1].
"
Step 4. Swap the pivot with the element just found"
	self swap: k with: i.! !

!Permutation methodsFor: 'mathematics' stamp: 'LC 8/19/1998 00:03'!
nonInversionSet
	| answer |
	answer _ Set new.
	1 to: self n - 1 do:
		[:i |
		i + 1 to: self n do:
			[:j |
			(self at: i) < (self at: j)
				ifTrue:
					[answer add: (Array with: (self at: i) with: (self at: j))]]].
	^ answer! !

!Permutation methodsFor: 'mathematics' stamp: 'LC 8/31/1998 08:57'!
orbitOf: k
	| answer elem |
	answer _ OrderedCollection with: k.
	elem _ k.
	[(elem _ self at: elem) = k]
		whileFalse: [answer add: elem].
	^ answer! !

!Permutation methodsFor: 'mathematics' stamp: 'LC 9/2/1998 14:02'!
sign
	^ self inversions \\ 2 = 0
		ifTrue: [1]
		ifFalse: [-1]! !

!Permutation methodsFor: 'mathematics' stamp: 'LC 8/18/1998 23:33'!
swap: i with: j
	| copy |
	copy _ self at: i.
	self at: i put: (self at: j).
	self at: j put: copy! !

!Permutation methodsFor: 'mathematics' stamp: 'LC 8/19/1998 00:06'!
totalDisplacement
	| answer |
	answer _ 0.
	1 to: self n do:
		[:k | answer _ answer + ((self at: k) - k) abs].
	^ answer! !

!Permutation methodsFor: 'enumerating' stamp: 'LC 8/18/1998 23:41'!
do: aBlock
	contents do: aBlock! !

!Permutation methodsFor: 'printing' stamp: 'LC 8/18/1998 23:36'!
printOn: aStream
	contents printOn: aStream! !

!Permutation methodsFor: 'private' stamp: 'LC 8/18/1998 23:31'!
at: anIndex insert: anObject
	self n - 1 to: anIndex + 1 by: -1 do:
		[:k | self at: k put: (self at: k + 1)].
	self at: anIndex put: anObject! !

!Permutation methodsFor: 'private' stamp: 'LC 8/18/1998 23:32'!
at: k put: j
	"Private"
	contents at: k put: j! !

!Permutation methodsFor: 'private' stamp: 'LC 8/31/1998 09:24'!
contents
	"Private"
	^ contents! !

!Permutation methodsFor: 'private' stamp: 'LC 8/31/1998 09:32'!
fromCollection: aCollection
	"Private"
	| i |
	i _ 1.
	aCollection do:
		[:a |
		self at: i put: a.
		i _ i + 1]
! !

!Permutation methodsFor: 'private' stamp: 'LC 8/31/1998 09:23'!
initialize: n
	"Private"
	contents _ Array new: n! !

!Permutation methodsFor: 'morphic' stamp: 'LC 8/19/1998 00:37'!
morphicWrapperClass
	^ Smalltalk at: #PermutationWrapper! !


!Permutation class methodsFor: 'all' stamp: 'LC 8/31/1998 09:25'!
fromInversion: aCollection
	| contents n b |
	contents _ Array new: (n _ aCollection size).
	n to: 1 by: -1 do:
		[:j |
		b _ (aCollection at: j) + 1.
		n - 1 to: b by: -1 do: [:k | contents at: k + 1 put: (contents at: k)].
		contents at: b put: j].
	^ self newFrom: contents! !

!Permutation class methodsFor: 'all' stamp: 'LC 8/18/1998 23:27'!
identity: n
	| answer |
	answer _ self new: n.
	1 to: n do: [:k | answer at: k put: k].
	^ answer! !

!Permutation class methodsFor: 'all' stamp: 'LC 8/18/1998 23:35'!
new: n
	^ self new initialize: n! !

!Permutation class methodsFor: 'all' stamp: 'LC 8/31/1998 09:30'!
newFrom: aCollection
	^ (self new: aCollection size) fromCollection: aCollection
! !


!PermutationWrapper methodsFor: 'initialization' stamp: 'LC 8/19/1998 02:49'!
initialize
	super initialize.
	self stopStepping.
	self object: (Permutation identity: 4)! !

!PermutationWrapper methodsFor: 'updating' stamp: 'LC 8/19/1998 02:59'!
labelAtPoint: ij
	| i j string pi |
	i _ ij x.
	j _ ij y.
	pi _ self object.
	(pi at: i) = j
		ifTrue: [string _ '#']
		ifFalse:
			[(i < (pi indexOf: j) and: [(pi at: i) > j])
				ifTrue: [string _ ':']
				ifFalse: [string _ '']].
	^ string! !

!PermutationWrapper methodsFor: 'updating' stamp: 'LC 8/19/1998 02:26'!
row: i
	| frame |
	frame _ AlignmentMorph new
		inset: 0;
		color: Color transparent;
		orientation: #horizontal;
		vResizing: #shrinkWarp;
		extent: (20 * self object n) @ 20.
	self object n to: 1 by: -1 do:
		[:j |
		frame addMorph:
			(self tile
				label: (self labelAtPoint: i @ j);
				extent: 20 @ 20)].
	^ frame! !

!PermutationWrapper methodsFor: 'updating' stamp: 'LC 8/19/1998 01:28'!
tile
	| onColor offColor |
	offColor _ Color r: 0.4 g: 0.8 b: 0.6.
	onColor _ offColor mixed: 1/2 with: Color white.
	^ SimpleSwitchMorph new
		offColor: offColor;
		onColor: onColor;
		borderWidth: 1;
		extent: 20 @ 20! !

!PermutationWrapper methodsFor: 'updating' stamp: 'LC 8/19/1998 02:29'!
updateContents
	| n frame |
	self removeAllMorphs.
	n _ self object n.
	frame _ AlignmentMorph new
		inset: 0;
		color: Color transparent;
		orientation: #vertical;
		vResizing: #shrinkWarp;
		extent: (20 * n) @ (20 * n).
	n to: 1 by: -1 do: [:i | frame addMorph: (self row: i)].
	self extent: frame extent + (20 @ 20).
	frame position: self position + (10 @ 10).
	self addMorph: frame.
	self changed! !

!PermutationWrapper methodsFor: 'menu' stamp: 'LC 8/28/1998 00:28'!
doubleClickMenu: evt
	| menu |
	menu _ super doubleClickMenu: evt.
	(self world isStepping: self)
		ifTrue: [
			menu
				add: 'stop stepping'
				target: self
				selector: #stopStepping]
		ifFalse: [
			menu
				add: 'start stepping'
				target: self
				selector: #startStepping].
	^ menu! !

!PermutationWrapper methodsFor: 'stepping' stamp: 'LC 8/19/1998 02:47'!
step
	self object next.
	self updateContents! !

!PermutationWrapper methodsFor: 'stepping' stamp: 'LC 8/19/1998 03:09'!
stepTime
	^ 1000! !

!PermutationWrapper methodsFor: 'stepping' stamp: 'LC 8/19/1998 02:51'!
wantsSteps
	^ false! !


